/* @(#)dspout.c	15.1.1.1 (ES0-DMD) 01/12/01 18:16:52 */
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

/* ++++++++++++++++++++++++++++++++++++++++++++++++++
 
.IDENTIFICATION
  dspout.c
  K. Banse                        ESO - Garching
  4.30      851030
  8.15	    910708		8.20	  910904	8.25	910912
  8.30	    911015		8.45	  920218	9.00	920423
 
.KEYWORDS
  help facility
 
.PURPOSE
  display help information
 
.ALGORITHM
  cumbersome but rather straight forward ...
  but do not write that into the logfile (to save space...) unless
  keyword LOG(3) is set

.INPUT/OUTPUT
  the following keywords are used:

  INPUTC/C/1/40      help command/qualif help_string (=command/qualif)
  CONTEXT/C/1/64      currently enabled contexts
       
.VERSIONS
  5.00            move towards FORTRAN 77 and UNIX environment
  6.30            fix bug in HLPDIR (context file may also be in MID_WORK ...)
  6.80            get no. of lines from LOG(10)
  6.90            adapt HLPDIR to new directory structure
  7.00		  new filenames for help files: commanqual.hlp or com_qual.hlp
  8.00		  new version of helper written in C !!
  8.10		  accept also complete pathname in !HELP =  (hlpdir)
  8.15		  do not use termwindow stuff if AUX_MODE(8) = 0
  8.20		  remodel HELP/CL business
  8.30		  fix bugs with help printing + new types for alll.* files
  8.35		  bug file now in /midas/'version' with filename Midas.Bugs
  8.40		  open terminal correctly with TermWindow
  8.45		  fix VMS problems in hlpdir
  9.00		  split up into more subroutines + prepare for UIMX
       
 -------------------------------------------------- */

#include <midas_def.h>
 
static char  *cpntr, *savpntr;





dspout(record)
char  *record;		/* IN: string to be displayed */
 
{

char    reco[88];

int  nn, n;
register int nr;
 

/*  throw away the '\' characters */

nn = strlen(record);
if (nn > 0)
   {
   n = 0;
   for (nr=0; nr<nn; nr++)
      {
      if (record[nr] != '\\')  
         reco[n++] = record[nr];
      else
         {
         if (nr == 0) return (0);			/* do nothing */
         }
      }
   reco[n] = '\0';
   }
else
   {
   reco[0] = ' ';
   reco[1] = '\0';
   }


SCTPUT(reco);

return (0); 
}

/*

*/

prepmem(yourpntr)

char  **yourpntr;

{

unsigned int  nobytes;
static int  firsty = 0;

char  *osmmget();

if (firsty == 0)
   {
   firsty = 1;
   nobytes = 800000;			/* allocate virtual memory for text */
   savpntr = osmmget(nobytes);
   }

*yourpntr = savpntr;
cpntr = savpntr;

}

SCTPUT(rec)
char *rec;

{

strcpy(cpntr,rec);
cpntr += strlen(rec);		/* now we point to the '\0' */
*cpntr++ = '\n';
*cpntr = '\0';			/* make sure we'll have an end */

}
